var At = Object.defineProperty;
var Ft = (e, t, n) => t in e ? At(e, t, { enumerable: !0, configurable: !0, writable: !0, value: n }) : e[t] = n;
var K = (e, t, n) => (Ft(e, typeof t != "symbol" ? t + "" : t, n), n);
import { defineComponent as de, ref as b, computed as p, h as mt, getCurrentInstance as ye, reactive as Ue, watch as me, onMounted as We, onBeforeUnmount as It, nextTick as Et } from "vue-demi";
import { openBlock as O, createElementBlock as j, createElementVNode as v, normalizeClass as m, mergeProps as ce, toHandlers as Me, withDirectives as ue, createBlock as Re, resolveDynamicComponent as bt, createCommentVNode as oe, vShow as Ne, Fragment as Pe, createTextVNode as je, toDisplayString as he, resolveComponent as we, withModifiers as Nt, normalizeStyle as Oe, renderList as Xe, renderSlot as G, createVNode as De, vModelText as Vt, createSlots as wt, withCtx as xe, normalizeProps as be, guardReactiveProps as ve, Transition as Tt } from "vue";
const Bt = [
  "_level",
  "_filterVisible",
  "_parent",
  "_loading",
  "_loaded",
  "_remote",
  "_keyField",
  "children",
  "setChildren"
];
class se {
  //#endregion Properties
  constructor(t, n = null, l = "id", a = !1) {
    /** 节点层级 */
    K(this, "_level", 0);
    /** 多选是否选中 */
    K(this, "checked", !1);
    /** 单选是否选中 */
    K(this, "selected", !1);
    /** 是否半选状态 */
    K(this, "indeterminate", !1);
    /** 是否禁用 */
    K(this, "disabled", !1);
    /** 是否展开 */
    K(this, "expand", !1);
    /** 是否可见 */
    K(this, "visible", !0);
    /** 过滤后是否可见，如果为 false 则在其他可见情况下也是不可见的 */
    K(this, "_filterVisible", !0);
    /** 父节点 */
    K(this, "_parent", null);
    /** 子节点 */
    K(this, "children", []);
    /** 是否是子节点 */
    K(this, "isLeaf", !1);
    /** 节点是否正在加载 */
    K(this, "_loading", !1);
    /** 子节点是否已加载 */
    K(this, "_loaded", !1);
    this._keyField = l, this._remote = a;
    for (let s in t)
      Bt.indexOf(s) === -1 && (this[s] = t[s]);
    this[l] == null && (this[l] = Math.random().toString(36).substring(2)), this._parent = n, this._parent && (this._level = this._parent._level + 1), this.visible = this._parent === null || this._parent.expand && this._parent.visible, Array.isArray(t.children) && this.setChildren(t.children), this.children.length && (this._loaded = !0), this._remote || (this.isLeaf = !this.children.length);
  }
  /**
   * 设置子节点
   * @param children 子节点数据数组
   */
  setChildren(t) {
    this.children = t.map((n) => new se(
      Object.assign({}, n),
      this,
      this._keyField,
      this._remote
    ));
  }
}
var _e = /* @__PURE__ */ ((e) => (e.none = "none", e.parents = "parents", e.children = "children", e))(_e || {});
const Lt = [
  "setData",
  "setChecked",
  "setCheckedKeys",
  "checkAll",
  "clearChecked",
  "setSelected",
  "clearSelected",
  "setExpand",
  "setExpandKeys",
  "setExpandAll",
  "getCheckedNodes",
  "getCheckedKeys",
  "getIndeterminateNodes",
  "getSelectedNode",
  "getSelectedKey",
  "getExpandNodes",
  "getExpandKeys",
  "getCurrentVisibleNodes",
  "getNode",
  "getTreeData",
  "getFlatData",
  "getNodesCount",
  "insertBefore",
  "insertAfter",
  "append",
  "prepend",
  "remove",
  "filter",
  "showCheckedNodes",
  "loadRootNodes",
  "scrollTo"
];
var Dt = /* @__PURE__ */ ((e) => (e["bottom-start"] = "bottom-start", e["bottom-end"] = "bottom-end", e.bottom = "bottom", e["top-start"] = "top-start", e["top-end"] = "top-end", e.top = "top", e))(Dt || {}), Se = /* @__PURE__ */ ((e) => (e.top = "top", e.center = "center", e.bottom = "bottom", e))(Se || {}), J = /* @__PURE__ */ ((e) => (e.before = "before", e.body = "body", e.after = "after", e))(J || {});
const He = [
  "expand",
  "check",
  "click",
  "select",
  "node-dblclick",
  "node-right-click",
  "node-dragstart",
  "node-dragenter",
  "node-dragover",
  "node-dragleave",
  "node-drop"
];
class Mt {
  //#endregion Properties
  constructor(t) {
    //#region Properties
    /** 树数据 */
    K(this, "data", []);
    /** 扁平化的树数据 */
    K(this, "flatData", []);
    /** 树数据 map */
    K(this, "mapData", /* @__PURE__ */ Object.create(null));
    /** 未加载但已选中的节点 key ，每次 flattenData 的时候进行检查，将加载的节点从此数组中剔除 */
    K(this, "unloadCheckedKeys", []);
    /** 未加载但选中的单选节点 key */
    K(this, "unloadSelectedKey", null);
    /** 当前单选选中节点 key */
    K(this, "currentSelectedKey", null);
    /** 事件 listeners */
    K(this, "listenersMap", {});
    this.options = t;
  }
  setData(t, n = null, l = null) {
    this.data = t.map(
      (a) => new se(a, null, this.options.keyField, !!this.options.load)
    );
    for (let a in this.mapData)
      delete this.mapData[a];
    this.currentSelectedKey = null, this.flatData = this.flattenData(this.data), this.setUnloadCheckedKeys(l || []), n && (this.currentSelectedKey = null, this.setUnloadSelectedKey(n)), this.emit("visible-data-change"), this.emit("set-data");
  }
  //#region Set api
  /**
   * 设置单个节点多选选中
   * @param key 设置的节点 key
   * @param value 是否选中
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发 `data-change` 事件以通知外部刷新视图
   * @param filtering 是否正在过滤，如果是，则考虑 `filteredNodeCheckable` Prop，用于判断是否是用户点击节点触发的勾选
   */
  setChecked(t, n, l = !0, a = !0, s = !1) {
    const r = this.mapData[t];
    if (!r)
      return this.setUnloadChecked(t, n, l, a);
    r.disabled || r.checked && n || !r.checked && !r.indeterminate && !n || (this.options.cascade ? (this.checkNodeDownward(r, n, s), this.checkNodeUpward(r)) : r.checked = n, l && (r.checked ? this.emit("check", r) : this.emit("uncheck", r)), this.triggerCheckedChange(l, a));
  }
  /**
   * 设置单个未加载节点选中，不公开此 API
   */
  setUnloadChecked(t, n, l = !0, a = !0) {
    const s = this.findIndex(t, this.unloadCheckedKeys);
    n ? s === -1 && this.unloadCheckedKeys.push(t) : s !== -1 && this.unloadCheckedKeys.splice(s, 1), this.triggerCheckedChange(l, a);
  }
  /**
   * 批量选中/取消多选选中节点
   * @param keys 选中的节点 key 数组
   * @param value 是否选中
   * @param triggerEvent 是否触发事件
   */
  setCheckedKeys(t, n, l = !0, a = !0) {
    t.forEach((s) => {
      this.setChecked(s, n, !1, !1);
    }), this.triggerCheckedChange(l, a);
  }
  /**
   * 多选勾选全部节点
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发视图刷新
   */
  checkAll(t = !0, n = !0) {
    if (this.options.cascade) {
      const l = (a) => {
        a.forEach((s) => {
          s.disabled ? l(s.children) : this.setChecked(s[this.options.keyField], !0, !1, !1);
        });
      };
      l(this.data);
    } else {
      const l = this.flatData.length;
      for (let a = 0; a < l; a++) {
        const s = this.flatData[a];
        this.setChecked(s[this.options.keyField], !0, !1, !1);
      }
    }
    this.triggerCheckedChange(t, n);
  }
  /**
   * 清除所有多选已选
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发视图刷新
   */
  clearChecked(t = !0, n = !0) {
    this.getCheckedNodes().forEach((a) => {
      this.setChecked(a[this.options.keyField], !1, !1, !1);
    }), this.unloadCheckedKeys = [], this.triggerCheckedChange(t, n);
  }
  /**
   * 触发 checked-change 的快捷方法
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发视图刷新
   */
  triggerCheckedChange(t = !0, n = !0) {
    t && this.emit("checked-change", this.getCheckedNodes(), this.getCheckedKeys()), n && this.emit("render-data-change");
  }
  /**
   * 设置单选选中
   * @param key 选中节点 key
   * @param value 是否选中
   * @param triggerEvent 是否触发事件
   */
  setSelected(t, n, l = !0, a = !0) {
    const s = this.mapData[t];
    if (!s)
      return this.setUnloadSelected(t, n, l, a);
    s.disabled || s.selected !== n && (t === this.currentSelectedKey ? n || (s.selected = n, this.currentSelectedKey = null) : n && (this.currentSelectedKey === null ? (s.selected = n, this.currentSelectedKey = s[this.options.keyField]) : (this.mapData[this.currentSelectedKey] && (this.mapData[this.currentSelectedKey].selected = !1), s.selected = n, this.currentSelectedKey = s[this.options.keyField])), l && (s.selected ? this.emit("select", s) : this.emit("unselect", s), this.emit(
      "selected-change",
      this.getSelectedNode(),
      this.getSelectedKey()
    )), a && this.emit("render-data-change"));
  }
  /**
   * 设置未加载单选选中节点，不公开此 API
   */
  setUnloadSelected(t, n, l = !0, a = !0) {
    n ? (this.currentSelectedKey && this.setSelected(this.currentSelectedKey, !1, !1, !1), this.unloadSelectedKey = t) : this.unloadSelectedKey === t && (this.unloadSelectedKey = null), l && this.emit(
      "selected-change",
      this.getSelectedNode(),
      this.getSelectedKey()
    ), a && this.emit("render-data-change");
  }
  /**
   * 清除当前单选选中
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发视图刷新
   */
  clearSelected(t = !0, n = !0) {
    this.currentSelectedKey && this.mapData[this.currentSelectedKey] ? this.setSelected(
      this.currentSelectedKey,
      !1,
      t,
      n
    ) : this.unloadSelectedKey !== null && (this.unloadSelectedKey = null, t && this.emit(
      "selected-change",
      this.getSelectedNode(),
      this.getSelectedKey()
    ), n && this.emit("render-data-change"));
  }
  /**
   * 设置节点展开
   * @param key 节点 key
   * @param value 是否展开
   * @param expandParent 展开节点时是否同时展开父节点
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发 `data-change` 事件以通知外部刷新视图
   */
  setExpand(t, n, l = !1, a = !0, s = !0) {
    const r = this.mapData[t];
    if (!(!r || !l && r.isLeaf) && r.expand !== n) {
      if (!r.isLeaf) {
        if (typeof this.options.load == "function") {
          if (!r._loaded && !r._loading && n) {
            r._loading = !0, s && this.emit("visible-data-change"), new Promise((h, g) => {
              const A = this.options.load;
              A(r, h, g);
            }).then((h) => {
              if (Array.isArray(h)) {
                const g = this.findIndex(r);
                if (g === -1)
                  return;
                r._loaded = !0, r.expand = n, r.setChildren(h);
                const A = this.getCheckedKeys(), V = this.flattenData(
                  r.children,
                  this.getSelectedKey === null
                );
                this.flatData.splice(g + 1, 0, ...V), this.setUnloadCheckedKeys(A), this.unloadSelectedKey !== null && this.setUnloadSelectedKey(this.unloadSelectedKey), this.emit("set-data");
              }
            }).catch((h) => {
            }).then(() => {
              r._loading = !1, a && this.emit("expand", r), s && this.emit("visible-data-change");
            });
            return;
          } else if (r._loading)
            return;
        }
        r.expand = n;
        const d = [...r.children];
        for (; d.length; )
          d[0].expand && d[0].children.length && d.push(...d[0].children), d[0]._filterVisible === !1 ? d[0].visible = !1 : d[0].visible = d[0]._parent === null || d[0]._parent.expand && d[0]._parent.visible, d.shift();
        a && this.emit("expand", r), s && this.emit("visible-data-change");
      }
      l && r._parent && n && this.setExpand(
        r._parent[this.options.keyField],
        n,
        l,
        !1,
        s
      );
    }
  }
  /**
   * 批量设置节点展开/折叠
   * @param keys 展开的节点 key 数组
   * @param value 是否展开
   */
  setExpandKeys(t, n, l = !0) {
    t.forEach((a) => {
      this.setExpand(a, n, !1, !1, !1);
    }), l && this.emit("visible-data-change");
  }
  setExpandAll(t, n = !0) {
    this.flatData.forEach((l) => {
      (!this.options.load || l._loaded) && this.setExpand(l[this.options.keyField], t, !1, !1, !1);
    }), n && this.emit("visible-data-change");
  }
  //#endregion Set api
  //#region Get api
  /**
   * 获取多选选中节点
   * @param ignoreMode 忽略模式，可选择忽略父节点或子节点，默认值是 CTree 的 ignoreMode Prop
   */
  getCheckedNodes(t = this.options.ignoreMode) {
    if (t === _e.children) {
      const n = [], l = (a) => {
        a.forEach((s) => {
          s.checked ? n.push(s) : !s.isLeaf && s.indeterminate && l(s.children);
        });
      };
      return l(this.data), n;
    } else
      return this.flatData.filter((n) => t === _e.parents ? n.checked && n.isLeaf : n.checked);
  }
  /**
   * 获取多选选中的节点 key ，包括未加载的 key
   * @param ignoreMode 忽略模式，同 `getCheckedNodes`
   */
  getCheckedKeys(t = this.options.ignoreMode) {
    return this.getCheckedNodes(t).map((n) => n[this.options.keyField]).concat(this.unloadCheckedKeys);
  }
  /**
   * 获取多选半选状态节点
   */
  getIndeterminateNodes() {
    return this.flatData.filter((t) => t.indeterminate);
  }
  /**
   * 获取当前单选选中节点
   */
  getSelectedNode() {
    return this.currentSelectedKey === null ? null : this.mapData[this.currentSelectedKey] || null;
  }
  /**
   * 获取当前单选选中节点 key ，有可能是未加载的选中项
   */
  getSelectedKey() {
    return this.currentSelectedKey || this.unloadSelectedKey || null;
  }
  /**
   * 获取未加载但多选选中的节点
   */
  getUnloadCheckedKeys() {
    return this.unloadCheckedKeys;
  }
  /**
   * 获取展开节点
   */
  getExpandNodes() {
    return this.flatData.filter((t) => !t.isLeaf && t.expand);
  }
  /**
   * 获取展开节点 keys
   */
  getExpandKeys() {
    return this.getExpandNodes().map((t) => t[this.options.keyField]);
  }
  /**
   * 根据节点 key  获取节点
   * @param key 节点 key
   */
  getNode(t) {
    return this.mapData[t] || null;
  }
  //#endregion Get api
  //#region Node transfer api
  // 这边的 referenceKey 都是被执行的节点，比如 insertBefore ，在这里 referenceKey 就是指要插入到 referenceKey 节点前面
  insertBefore(t, n) {
    const l = this.getInsertedNode(t, n);
    if (!l)
      return null;
    this.remove(l[this.options.keyField], !1);
    const s = this.mapData[n]._parent, r = this.findIndex(
      n,
      s && s.children
    ), d = this.findIndex(n), h = s && -1 || this.findIndex(n, this.data);
    return this.insertIntoStore(l, s, r, d, h), this.emit("visible-data-change"), l;
  }
  insertAfter(t, n) {
    const l = this.getInsertedNode(t, n);
    if (!l)
      return null;
    this.remove(l[this.options.keyField], !1);
    const a = this.mapData[n], s = a._parent, r = this.findIndex(n, s && s.children) + 1, d = this.flatData.length, h = this.findIndex(n);
    let g = h + 1;
    for (let V = h + 1; V <= d; V++) {
      if (V === d) {
        g = V;
        break;
      }
      if (this.flatData[V]._level <= a._level) {
        g = V;
        break;
      }
    }
    const A = s && -1 || this.findIndex(n, this.data) + 1;
    return this.insertIntoStore(l, s, r, g, A), this.emit("visible-data-change"), l;
  }
  append(t, n) {
    const l = this.mapData[n];
    if (!l.isLeaf) {
      const r = l.children.length;
      return this.insertAfter(
        t,
        l.children[r - 1][this.options.keyField]
      );
    }
    const a = this.getInsertedNode(t, n, !0);
    if (!a)
      return null;
    this.remove(a[this.options.keyField], !1);
    const s = this.findIndex(n) + 1;
    return this.insertIntoStore(a, l, 0, s), this.emit("visible-data-change"), a;
  }
  prepend(t, n) {
    const l = this.mapData[n];
    if (!l.isLeaf)
      return this.insertBefore(
        t,
        l.children[0][this.options.keyField]
      );
    const a = this.getInsertedNode(t, n, !0);
    if (!a)
      return null;
    this.remove(a[this.options.keyField], !1);
    const s = this.findIndex(n) + 1;
    return this.insertIntoStore(a, l, 0, s), this.emit("visible-data-change"), a;
  }
  /**
   * 删除节点
   * @param removedKey 要删除的节点 key
   */
  remove(t, n = !0) {
    const l = this.mapData[t];
    if (!l)
      return null;
    const a = this.findIndex(l);
    if (a === -1)
      return null;
    let s = 1;
    const r = this.flatData.length;
    for (let h = a + 1; h < r && this.flatData[h]._level > l._level; h++)
      s++;
    this.flatData.splice(a, s);
    const d = (h) => {
      const g = this.mapData[h];
      delete this.mapData[h], g.children.forEach((A) => d(A[this.options.keyField]));
    };
    if (d(t), !l._parent) {
      const h = this.findIndex(l, this.data);
      h > -1 && this.data.splice(h, 1);
    }
    if (l._parent) {
      const h = this.findIndex(l, l._parent.children);
      h !== -1 && l._parent.children.splice(h, 1), l._parent.isLeaf = !l._parent.children.length, l._parent.isLeaf && (l._parent.expand = !1, l._parent.indeterminate = !1), this.updateMovingNodeStatus(l);
    }
    return n && this.emit("visible-data-change"), l;
  }
  getInsertedNode(t, n, l = !1) {
    const a = this.mapData[n];
    if (!a)
      return null;
    const s = l ? a : a._parent;
    if (t instanceof se)
      return t[this.options.keyField] === n ? null : t;
    if (typeof t == "object") {
      if (t[this.options.keyField] === n)
        return null;
      const r = this.mapData[t[this.options.keyField]];
      return r || new se(
        t,
        s,
        this.options.keyField,
        !!this.options.load
      );
    } else
      return !this.mapData[t] || t === n ? null : this.mapData[t];
  }
  /**
   * 将一个节点插入 store 记录中
   * @param node 要插入的节点
   * @param parentNode 要插入节点的父节点
   * @param childIndex 如果有父节点，则需提供要插入的节点在同级节点中的顺序
   * @param flatIndex 在 flatData 中的索引
   * @param dataIndex 如果没有父节点，需要提供节点在 data 中的索引
   */
  insertIntoStore(t, n, l, a, s) {
    if (a === -1)
      return;
    l !== -1 && n && n.children.splice(l, 0, t), t._parent = n, n ? (n.isLeaf = !1, this.setExpand(
      n[this.options.keyField],
      !0,
      !1,
      !1,
      !1
    )) : typeof s == "number" && s > -1 && this.data.splice(s, 0, t);
    const r = this.flattenData([t]);
    t._level = n ? n._level + 1 : 0, r.forEach(
      (d) => d._level = d._parent ? d._parent._level + 1 : 0
    ), this.flatData.splice(a, 0, ...r), this.updateMovingNodeStatus(t);
  }
  updateMovingNodeStatus(t) {
    this.checkNodeUpward(t), this.triggerCheckedChange(), t.selected && this.setSelected(t[this.options.keyField], !0);
  }
  //#endregion Node transfer api
  /**
   * 过滤本地节点数据
   * @param keyword 过滤关键词
   * @param filterMethod 过滤方法
   */
  filter(t, n) {
    const l = [];
    this.flatData.forEach((a) => {
      a._filterVisible = a._parent && a._parent._filterVisible || n(t, a), a.visible = a._filterVisible, a._filterVisible && l.push(a);
    }), l.forEach((a) => {
      const s = [];
      let r = a._parent;
      for (; r; )
        s.unshift(r), r = r._parent;
      s.forEach((d) => {
        d._filterVisible = !0, d.visible = (d._parent === null || d._parent.expand && d._parent.visible) && d._filterVisible, this.options.expandOnFilter && this.setExpand(
          d[this.options.keyField],
          !0,
          !1,
          !1,
          !1
        );
      }), a.visible = a._parent === null || a._parent.expand && a._parent.visible;
    }), this.emit("visible-data-change");
  }
  /**
   * 过滤未加载多选节点，对比最终勾选节点是否有变化并触发 checked-change 事件
   * @param keys 全量选中节点 key 数组，包括加载与未加载选中节点
   */
  setUnloadCheckedKeys(t) {
    this.unloadCheckedKeys = t;
    const n = t.concat(), l = this.unloadCheckedKeys.length;
    for (let s = l - 1; s >= 0; s--) {
      const r = this.unloadCheckedKeys[s];
      this.mapData[r] && (this.setChecked(r, !0, !1, !1), this.unloadCheckedKeys.splice(s, 1));
    }
    const a = this.getCheckedKeys();
    a.length === n.length && a.every(
      (s) => n.some((r) => r === s)
    ) || this.emit("checked-change", this.getCheckedNodes(), a);
  }
  /**
   * 过滤未加载单选选中节点，对比是否有变化并触发 selected-change 事件
   * @param key 节点 key
   */
  setUnloadSelectedKey(t) {
    const n = this.getSelectedKey();
    this.mapData[t] ? (this.setSelected(t, !0, !1), this.unloadSelectedKey = null) : (this.currentSelectedKey && this.setSelected(this.currentSelectedKey, !1, !1), this.unloadSelectedKey = t);
    const l = this.getSelectedKey();
    l !== n && this.emit("selected-change", this.getSelectedNode(), l);
  }
  /**
   * 保存扁平化的节点数据 `flatData` 与节点数据 Map `mapData`
   * @param nodes 树状节点数据
   * @param overrideSelected 是否根据数据设置 `selected`
   */
  flattenData(t, n = !0, l = []) {
    const a = t.length;
    for (let s = 0; s < a; s++) {
      const r = t[s], d = r[this.options.keyField];
      if (l.push(r), this.mapData[d])
        throw new Error("[CTree] Duplicate tree node key.");
      this.mapData[d] = r, r.checked && this.options.cascade && (this.checkNodeDownward(r, !0), this.checkNodeUpward(r)), r.selected && n && (this.clearSelected(!1, !1), this.currentSelectedKey = r[this.options.keyField], this.emit("selected-change", r, this.currentSelectedKey)), (this.options.defaultExpandAll || r.expand) && !this.options.load && !r.isLeaf && (r.expand = !1, this.setExpand(r[this.options.keyField], !0, !1, !1, !1)), r.children.length && this.flattenData(r.children, n, l);
    }
    return l;
  }
  //#region Check nodes
  /**
   * 向下勾选/取消勾选节点，包括自身
   * @param node 需要向下勾选的节点
   * @param value 勾选或取消勾选
   * @param filtering 是否正在过滤，如果是，则考虑 `filteredNodeCheckable` Prop
   */
  checkNodeDownward(t, n, l = !1) {
    if (t.children.forEach((a) => {
      this.checkNodeDownward(a, n, l);
    }), t.isLeaf || this.options.load && !t.children.length) {
      if (!t.disabled) {
        if (l && !this.options.filteredNodeCheckable && !t._filterVisible)
          return;
        t.checked = n, t.indeterminate = !1;
      }
    } else
      this.checkParentNode(t);
  }
  /**
   * 向上勾选/取消勾选父节点，不包括自身
   * @param node 需要勾选的节点
   */
  checkNodeUpward(t) {
    let n = t._parent;
    for (; n; )
      this.checkParentNode(n), n = n._parent;
  }
  /**
   * 根据子节点的勾选状态更新当前父节点的勾选状态
   * @param node 需要勾选的节点
   */
  checkParentNode(t) {
    const n = t.children.length;
    if (!n)
      return;
    let l = !1, a = !1, s = !1;
    for (let r = 0; r < n; r++) {
      const d = t.children[r];
      if (d.checked ? l = !0 : a = !0, l && a || d.indeterminate) {
        s = !0, t.checked = !1, t.indeterminate = !0;
        break;
      }
    }
    s || (t.checked = l, t.indeterminate = !1);
  }
  //#endregion Check nodes
  //#region Utils
  /**
   * 搜索节点在指定数组中的位置
   */
  findIndex(t, n = this.flatData) {
    if (n !== null) {
      let l = t instanceof se ? t[this.options.keyField] : t;
      const a = n.length;
      for (let s = 0; s < a; s++)
        if (n[0] instanceof se) {
          if (l === n[s][this.options.keyField])
            return s;
        } else if (l === n[s])
          return s;
    }
    return -1;
  }
  //#endregion Utils
  //#region Mini EventTarget
  on(t, n) {
    this.listenersMap[t] || (this.listenersMap[t] = []);
    let l = [];
    Array.isArray(n) ? l = n : l = [n], l.forEach((a) => {
      this.listenersMap[t].indexOf(a) === -1 && this.listenersMap[t].push(a);
    });
  }
  off(t, n) {
    if (this.listenersMap[t])
      if (!n)
        this.listenersMap[t] = [];
      else {
        const l = this.listenersMap[t].indexOf(n);
        l > -1 && this.listenersMap[t].splice(l, 1);
      }
  }
  emit(t, ...n) {
    if (!this.listenersMap[t])
      return;
    const l = this.listenersMap[t].length;
    for (let a = 0; a < l; a++)
      this.listenersMap[t][a](...n);
  }
  disposeListeners() {
    for (const t in this.listenersMap)
      this.listenersMap[t] = [];
  }
  //#endregion Mini EventTarget
}
const Rt = de({
  name: "CLoadingIcon"
}), fe = (e, t) => {
  const n = e.__vccOpts || e;
  for (const [l, a] of t)
    n[l] = a;
  return n;
}, Ot = { viewBox: "0 0 50 50" }, xt = /* @__PURE__ */ v("circle", {
  class: "ctree-loading-icon__circle",
  cx: "25",
  cy: "25",
  r: "20",
  fill: "none",
  "stroke-width": "5",
  "stroke-miterlimit": "10"
}, null, -1), Ht = [
  xt
];
function Ut(e, t, n, l, a, s) {
  return O(), j("svg", Ot, Ht);
}
const _t = /* @__PURE__ */ fe(Rt, [["render", Ut]]), I = "ctree-tree-node", Wt = de({
  name: "CTreeNode",
  components: {
    LoadingIcon: _t
  },
  props: {
    /** 节点数据，注意！！为了性能，不让 Vue 监听过多属性，这个 data 不是完整的 TreeNode ，不包括 _parent 和 children 属性 */
    data: Object,
    /** 节点标题字段 */
    titleField: {
      type: String,
      default: ""
    },
    /** 节点唯一标识字段 */
    keyField: String,
    /** 节点渲染 render 函数 */
    render: Function,
    renderIcon: Function,
    /** 是否可多选 */
    checkable: Boolean,
    /** 是否可单选 */
    selectable: Boolean,
    /** 点击已选中节点是否取消选中 */
    unselectOnClick: Boolean,
    /** 是否禁用所有节点 */
    disableAll: Boolean,
    /** 是否可拖拽 */
    draggable: Boolean,
    /** 是否可放置 */
    droppable: Boolean,
    getNode: Function
  },
  emits: [...He],
  setup(e, { emit: t }) {
    var P, N;
    const n = b(!1), l = b(!1), a = b(!1), s = e.keyField, r = e.getNode, d = p(() => {
      var c, f, D, S, _, ae;
      return [
        `${I}__wrapper`,
        {
          [`${I}__wrapper_is-leaf`]: (c = e.data) == null ? void 0 : c.isLeaf,
          [`${I}_disabled`]: (f = e.data) == null ? void 0 : f.selected
        },
        // 复选
        {
          [`${I}_checked`]: e.checkable && ((D = e.data) == null ? void 0 : D.checked),
          [`${I}_indeterminate`]: e.checkable && ((S = e.data) == null ? void 0 : S.indeterminate)
        },
        // 单选
        {
          [`${I}_selected`]: (_ = e.data) == null ? void 0 : _.selected,
          [`${I}_hover`]: !((ae = e.data) != null && ae.selected)
        }
      ];
    }), h = p(() => [
      `${I}__node-body`,
      {
        [`${I}__drop_active`]: n.value
      }
    ]), g = p(() => [
      `${I}__drop`,
      {
        [`${I}__drop_active`]: l.value
      }
    ]), A = p(() => [
      `${I}__drop`,
      {
        [`${I}__drop_active`]: a.value
      }
    ]), V = p(() => {
      var c;
      return [
        `${I}__square`,
        `${I}__expand`,
        {
          [`${I}__expand_active`]: (c = e.data) == null ? void 0 : c.expand
        }
      ];
    }), L = p(() => [`${I}__loading-icon`]), Q = p(() => {
      var c, f;
      return [
        `${I}__title`,
        {
          [`${I}__title_disabled`]: e.disableAll || ((c = e.data) == null ? void 0 : c.disabled)
        },
        {
          [`${I}__title_selected`]: (f = e.data) == null ? void 0 : f.selected
        }
      ];
    }), w = p(() => r(e.data ? e.data[s] : "") || e.data || {}), T = ((P = e.data) == null ? void 0 : P.render) || e.render || null, X = p(() => de({
      name: "Render",
      functional: !0,
      render() {
        return typeof T != "function" ? mt("div") : T(w.value);
      }
    })), B = ((N = e.data) == null ? void 0 : N.renderIcon) || e.renderIcon || null, M = p(() => de({
      name: "Render",
      functional: !0,
      render() {
        return typeof T != "function" ? mt("div") : T(w.value);
      }
    })), H = p(() => {
      var f;
      let c = {};
      return e.draggable && !e.disableAll && !((f = e.data) != null && f.disabled) && (c = {
        dragstart: k
      }), c;
    }), ie = p(() => {
      let c = {};
      return e.droppable && (c = {
        dragenter: C.bind(ye()),
        dragover: E.bind(ye()),
        dragleave: u.bind(ye()),
        drop: x.bind(ye())
      }), c;
    });
    function Z() {
      var c;
      (c = e.data) != null && c.isLeaf || t("expand", w.value);
    }
    function Y() {
      var c;
      e.disableAll || (c = e.data) != null && c.disabled || !e.checkable || t("check", w.value);
    }
    function te(c) {
      var f, D;
      if (console.log(this, "this"), t("click", w.value, c), e.selectable) {
        if (e.disableAll || (f = e.data) != null && f.disabled || (D = e.data) != null && D.selected && !e.unselectOnClick)
          return;
        t("select", w.value);
      } else
        e.checkable ? Y() : Z();
    }
    function ne(c) {
      t("node-dblclick", w.value, c);
    }
    function ee(c) {
      t("node-right-click", w.value, c);
    }
    const le = b();
    function z(c) {
      const f = le.value.getBoundingClientRect(), D = f.height, S = c.clientY - f.top;
      return S <= D * 0.3 ? J.before : S <= D * (0.3 + 0.4) ? J.body : J.after;
    }
    function W(c, f = !1) {
      l.value = !1, n.value = !1, a.value = !1, f || (c === J.before ? l.value = !0 : c === J.body ? n.value = !0 : c === J.after && (a.value = !0));
    }
    function k(c) {
      var f;
      c.dataTransfer && c.dataTransfer.setData("node", JSON.stringify(e.data)), (f = e.data) != null && f.expand && Z(), t("node-dragstart", w.value, c);
    }
    function C(c) {
      c.preventDefault();
      const f = z(c);
      W(f), t("node-dragenter", w.value, c, f);
    }
    function E(c) {
      c.preventDefault();
      const f = z(c);
      W(f), t("node-dragover", w.value, c, f);
    }
    function u(c) {
      const f = z(c);
      W(f, !0), t("node-dragleave", w.value, c, f);
    }
    function x(c) {
      const f = z(c);
      W(f, !0), t("node-drop", w.value, c, f);
    }
    return {
      /** 节点拖拽 dragover */
      dragoverBody: n,
      /** 节点前拖拽 dragover */
      dragoverBefore: l,
      /** 节点后拖拽 dragover */
      dragoverAfter: a,
      wrapperCls: d,
      nodeBodyCls: h,
      dropBeforeCls: g,
      dropAfterCls: A,
      // squareCls,
      expandCls: V,
      loadingIconCls: L,
      titleCls: Q,
      fullData: w,
      renderFunction: T,
      renderComponent: X,
      renderIconFunction: B,
      renderIconComponent: M,
      dragListeners: H,
      dropListeners: ie,
      // titleField,
      handleExpand: Z,
      handleCheck: Y,
      handleSelect: te,
      handleDblclick: ne,
      handleRightClick: ee,
      nodeBody: le
    };
  }
}), Pt = ["draggable"];
function jt(e, t, n, l, a, s) {
  var r;
  return O(), j("div", {
    class: m(e.wrapperCls)
  }, [
    v("div", {
      class: m(e.dropBeforeCls)
    }, null, 2),
    v("div", ce({
      ref: "nodeBody",
      class: e.nodeBodyCls
    }, Me(e.dropListeners, !0)), [
      ue(v("div", {
        class: m(e.expandCls)
      }, [
        v("div", {
          onClick: t[0] || (t[0] = (...d) => e.handleExpand && e.handleExpand(...d))
        }, [
          e.renderIconFunction ? (O(), Re(bt(e.renderIconComponent), { key: 0 })) : oe("", !0)
        ])
      ], 2), [
        [Ne, e.renderIconFunction]
      ]),
      v("div", ce({
        class: e.titleCls,
        onClick: t[1] || (t[1] = (...d) => e.handleSelect && e.handleSelect(...d)),
        onDblclick: t[2] || (t[2] = (...d) => e.handleDblclick && e.handleDblclick(...d)),
        onContextmenu: t[3] || (t[3] = (...d) => e.handleRightClick && e.handleRightClick(...d))
      }, Me(e.dragListeners, !0), {
        draggable: e.draggable && !e.disableAll && !((r = e.data) != null && r.disabled)
      }), [
        e.renderFunction ? (O(), Re(bt(e.renderComponent), { key: 0 })) : (O(), j(Pe, { key: 1 }, [
          je(he(e.data ? e.data[e.titleField] : ""), 1)
        ], 64))
      ], 16, Pt)
    ], 16),
    v("div", {
      class: m(e.dropAfterCls)
    }, null, 2)
  ], 2);
}
const Xt = /* @__PURE__ */ fe(Wt, [["render", jt]]), vt = [
  "expand",
  "select",
  "unselect",
  "selected-change",
  "check",
  "uncheck",
  "checked-change",
  "set-data"
], Yt = ["node-drop", "check", "select", "expand"], zt = de({
  name: "CTree",
  components: {
    CTreeNode: Xt,
    LoadingIcon: _t
  },
  emits: ["update:modelValue", ...He, ...vt],
  props: {
    /** 单选模式下为字符串或数字，多选模式下为数组或者以 separator 分隔的字符串。当即可单选又可多选时，value 是多选的值 */
    modelValue: [String, Number, Array],
    // modelValue: [
    //   String,
    //   Number,
    //   Array as PropType<TreeNodeKeyType[]>,
    // ],
    /** 传入的树数据。数据量大时，不建议通过 props 传入数据，建议用 `setData` 方法代替 */
    data: {
      type: Array,
      default: () => []
    },
    /** 供未加载且选中节点查询 title 字段值用的列表，格式与 `data` 一致即可 */
    unloadDataList: {
      type: Array,
      default: () => []
    },
    /** 过滤已选时是否在列表后面展示未加载的已选节点 */
    showUnloadCheckedNodes: {
      type: Boolean,
      default: !0
    },
    /** 数据为空时显示的文本 */
    emptyText: {
      type: String,
      default: "暂无数据"
    },
    /** 节点标题字段 */
    titleField: {
      type: String,
      default: "title"
    },
    /** 节点唯一标识字段 */
    keyField: {
      type: String,
      default: "id"
    },
    /** 多选模式下 value 分隔符 */
    separator: {
      type: String,
      default: ","
    },
    /** 是否可多选 */
    checkable: {
      type: Boolean,
      default: !1
    },
    /** 是否可单选 */
    selectable: {
      type: Boolean,
      default: !1
    },
    /** 是否可勾选被过滤节点 */
    filteredNodeCheckable: {
      type: Boolean,
      default: !1
    },
    /** 父子节点是否关联 */
    cascade: {
      type: Boolean,
      default: !0
    },
    /** 是否只启用子节点，当 `多选且父子不关联` 或 `单选` 时有效 */
    enableLeafOnly: {
      type: Boolean,
      default: !1
    },
    /** 是否禁用所有节点 */
    disableAll: {
      type: Boolean,
      default: !1
    },
    /** 是否默认展开所有节点 */
    defaultExpandAll: {
      type: Boolean,
      default: !1
    },
    /**
     * 默认展开的节点 key
     * @deprecated 下一个大版本将废弃，使用 expandedKeys 代替
     */
    defaultExpandedKeys: {
      type: Array,
      default: () => []
    },
    /** 展开的节点，该 Prop 变化时，树组件将会响应，建议配合事件使用 */
    expandedKeys: {
      type: Array,
      default: () => []
    },
    /** 是否可拖拽 */
    draggable: {
      type: Boolean,
      default: !1
    },
    /** 是否可放置 */
    droppable: {
      type: Boolean,
      default: !1
    },
    /** 在放置节点之前执行的方法，返回 true 允许放置， false 可阻止放置 */
    beforeDropMethod: {
      type: Function,
      default: () => () => !0
    },
    /** 忽略模式 */
    ignoreMode: {
      type: String,
      default: _e.none
    },
    /** 异步加载初始化时是否自动加载根节点 */
    autoLoad: {
      type: Boolean,
      default: !0
    },
    /** 异步加载方法 */
    load: Function,
    /** 节点渲染 render 函数 */
    render: Function,
    renderIcon: Function,
    /** 节点过滤方法 */
    filterMethod: Function,
    /**
     * 过滤时是否展开所有可见节点
     * 有时候可能因为开发者样式设置问题导致虚拟列表失效，而展开数据量又过多从而卡顿
     * 加上这个选项并不是为了解决上述问题，而仅仅作为一个可选项
     */
    expandOnFilter: {
      type: Boolean,
      default: !0
    },
    /** 点击已选中节点是否取消选中 */
    unselectOnClick: {
      type: Boolean,
      default: !0
    },
    /** 是否显示 loading 图标 */
    loading: {
      type: Boolean,
      default: !1
    },
    //#region Render nodes related props
    /** 根据节点最小高度计算数据总高度 */
    nodeMinHeight: {
      type: Number,
      default: 30
    },
    /** 子节点缩进 */
    nodeIndent: {
      type: Number,
      default: 20
    },
    /** 渲染节点数量，可见节点数大于此值且高度超过(容器可视高度能容纳节点数 + bufferNodeAmount)则不会渲染所有可见节点 */
    renderNodeAmount: {
      type: Number,
      default: 100
    },
    /** 当滚动到视野外的节点个数大于此值时刷新渲染节点 */
    bufferNodeAmount: {
      type: Number,
      default: 20
    },
    //#endregion Render nodes related props
    /** 节点根元素的 class ，传入函数以对每个节点定制 class */
    nodeClassName: {
      type: [
        String,
        Object,
        Array,
        Function
      ]
    }
    /**
     * 使用 padding 代替 margin 来展示子节点缩进
     * 此 Prop 是为了方便样式定制，在下个大版本将全部使用 padding
     * @deprecated
     */
    // usePadding: {
    //   type: Boolean,
    //   default: false
    // }
  },
  setup(e, t) {
    const n = "ctree-tree", l = (i, o) => {
      if (Array.isArray(i) && Array.isArray(o)) {
        if (i.length === o.length && i.every(
          (y) => o.some((R) => R === y)
        ))
          return !0;
      } else if (i === o)
        return !0;
      return !1;
    };
    let a = Ue([]), s = b([]);
    const r = b(0), d = b(0), h = b(0), g = b(0), A = b(0), V = b(0), L = b(0), Q = b(0), w = b(!1), T = b(
      Array.isArray(e.modelValue) ? e.modelValue.concat() : e.modelValue
    ), X = b(void 0), B = b(), M = b(), H = p(() => ({
      height: `${h.value}px`
    })), ie = p(() => ({
      height: `${g.value}px`
    })), Z = p(() => [`${n}__wrapper`]), Y = p(() => [`${n}__scroll-area`]), te = p(() => [`${n}__block-area`]), ne = p(() => [`${n}__empty`]), ee = p(() => [`${n}__empty-text_default`]), le = p(() => [`${n}__loading`]), z = p(() => [`${n}__loading-wrapper`]), W = p(() => [`${n}__loading-icon`]), k = p(() => [`${n}__iframe`]), C = He.reduce((i, o) => (Yt.indexOf(o) < 0 && (i[o] = (...y) => {
      t.emit.apply(t, [o, ...y]);
    }), i), {}), E = () => ({
      store: new Mt({
        keyField: e.keyField,
        ignoreMode: e.ignoreMode,
        filteredNodeCheckable: e.filteredNodeCheckable,
        cascade: e.cascade,
        defaultExpandAll: e.defaultExpandAll,
        load: e.load,
        expandOnFilter: e.expandOnFilter
      }),
      blockNodes: []
    });
    let u = E();
    me(
      () => e.modelValue,
      (i) => {
        if (e.checkable) {
          if (l(i, T.value))
            return;
          let o = [];
          Array.isArray(i) ? o = i.concat() : typeof i == "string" && (o = i === "" ? [] : i.split(e.separator)), u.store.clearChecked(!1, !1), u.store.setCheckedKeys(o, !0);
        } else if (e.selectable) {
          if (i === T.value)
            return;
          const o = u.store.getSelectedKey();
          i !== "" && i != null ? u.store.setSelected(i, !0) : (i === "" || i == null) && o && u.store.setSelected(o, !1);
        }
      }
    ), me(
      () => e.data,
      (i) => {
        x(i);
      }
    ), me(
      () => e.expandedKeys,
      () => {
        pe();
      }
    );
    function x(i) {
      Ee();
      let o = null, y = null;
      e.checkable ? Array.isArray(e.modelValue) ? o = e.modelValue.concat() : typeof e.modelValue == "string" && (o = e.modelValue === "" ? [] : e.modelValue.split(e.separator)) : e.selectable && !Array.isArray(e.modelValue) && (y = e.modelValue), u.store.setData(
        i,
        y,
        o
      ), pe();
    }
    function P(i, o) {
      u.store.setChecked(i, o);
    }
    function N(i, o) {
      u.store.setCheckedKeys(i, o);
    }
    function c() {
      u.store.checkAll();
    }
    function f() {
      u.store.clearChecked();
    }
    function D(i, o) {
      u.store.setSelected(i, o);
    }
    function S() {
      u.store.clearSelected();
    }
    function _(i, o, y = !0) {
      u.store.setExpand(i, o, y);
    }
    function ae(i, o) {
      u.store.setExpandKeys(i, o);
    }
    function Ye(i) {
      u.store.setExpandAll(i);
    }
    function ze(i) {
      return i = i || e.ignoreMode, u.store.getCheckedNodes(i);
    }
    function qe(i) {
      return i = i || e.ignoreMode, u.store.getCheckedKeys(i);
    }
    function Je() {
      return u.store.getIndeterminateNodes();
    }
    function Ge() {
      return u.store.getSelectedNode();
    }
    function Qe() {
      return u.store.getSelectedKey();
    }
    function Ze() {
      return u.store.getExpandNodes();
    }
    function et() {
      return u.store.getExpandKeys();
    }
    function tt() {
      return u.store.flatData.filter((i) => i._filterVisible);
    }
    function $e(i) {
      return u.store.getNode(i);
    }
    function nt() {
      return u.store.data;
    }
    function lt() {
      return u.store.flatData;
    }
    function at() {
      return u.store.flatData.length;
    }
    function st(i, o) {
      return u.store.insertBefore(i, o);
    }
    function it(i, o) {
      return u.store.insertAfter(i, o);
    }
    function rt(i, o) {
      return u.store.append(i, o);
    }
    function dt(i, o) {
      return u.store.prepend(i, o);
    }
    function ot(i) {
      return u.store.remove(i);
    }
    function ct(i, o) {
      const y = (R, $) => {
        const F = $[e.titleField];
        return F == null || !F.toString ? !1 : F.toString().toLowerCase().indexOf(R.toLowerCase()) > -1;
      };
      o = o || e.filterMethod || y, u.store.filter(i, o);
    }
    function ut(i) {
      if (!e.checkable)
        return;
      i = i ?? e.showUnloadCheckedNodes;
      const o = u.store.getCheckedNodes();
      if (u.store.filter("", (R, $) => $.checked), !i)
        return;
      const y = u.store.getUnloadCheckedKeys();
      if (y.length) {
        const R = y.map(($) => {
          const F = e.unloadDataList.concat(o);
          let Be = $;
          return F.some((Le) => Le[e.keyField] === $ && Le[e.titleField] != null ? (Be = Le[e.titleField], !0) : !1), new se(
            {
              [e.keyField]: $,
              [e.titleField]: Be,
              checked: !0,
              isLeaf: !0
            },
            null,
            e.keyField,
            !!e.load
          );
        });
        a = R, u.blockNodes.push(...R), ge(), re();
      }
    }
    function Ke() {
      return w.value = !0, new Promise((i, o) => {
        e.load && e.load(null, i, o);
      }).then((i) => {
        Array.isArray(i) && x(i);
      }).catch(() => {
      }).then(() => {
        w.value = !1;
      });
    }
    function ht(i, o = Se.top) {
      const y = u.store.mapData[i];
      if (!y || !y.visible)
        return;
      let R = -1;
      for (let F = 0; F < r.value; F++)
        if (u.blockNodes[F][e.keyField] === i) {
          R = F;
          break;
        }
      if (R === -1)
        return;
      let $ = R * e.nodeMinHeight;
      if (o === Se.center) {
        const F = B.value.clientHeight;
        $ = $ - (F - e.nodeMinHeight) / 2;
      } else if (o === Se.bottom) {
        const F = B.value.clientHeight;
        $ = $ - (F - e.nodeMinHeight);
      } else
        typeof o == "number" && ($ = $ - o);
      B.value && (B.value.scrollTop = $);
    }
    function pe() {
      e.expandedKeys.length && (u.store.setExpandAll(!1, !1), u.store.setExpandKeys(e.expandedKeys, !0));
    }
    function Ae() {
      if (a.length) {
        const i = u.store.getUnloadCheckedKeys();
        a.forEach((o) => {
          o.checked = i.indexOf(o[e.keyField]) > -1;
        });
      }
    }
    function ft(i) {
      !e.cascade && e.enableLeafOnly && !i.isLeaf || u.store.setChecked(
        i[e.keyField],
        i.indeterminate ? !0 : !i.checked,
        !0,
        !0,
        !0
      );
    }
    function pt(i) {
      e.enableLeafOnly && !i.isLeaf || u.store.setSelected(i[e.keyField], !i.selected);
    }
    function gt(i) {
      u.store.setExpand(i[e.keyField], !i.expand);
    }
    function kt(i, o, y) {
      if (e.droppable && o.dataTransfer)
        try {
          const $ = JSON.parse(o.dataTransfer.getData("node"))[e.keyField], F = i[e.keyField];
          if (e.beforeDropMethod(
            $,
            F,
            y
          )) {
            if ($ === F)
              return;
            y === J.before ? u.store.insertBefore($, F) : y === J.body || !i.isLeaf && i.expand ? u.store.prepend($, F) : y === J.after && u.store.insertAfter($, F), t.emit("node-drop", i, o, y, $e($));
          }
        } catch (R) {
          throw new Error(R);
        }
    }
    function Fe(i, o) {
      if (e.checkable) {
        let y = o;
        Array.isArray(e.modelValue) || (y = y.join(e.separator)), Array.isArray(y) ? T.value = y.concat() : T.value = y, t.emit("update:modelValue", y);
      }
    }
    function Ie(i, o) {
      if (e.selectable && !e.checkable) {
        const y = o || "";
        T.value = y, t.emit("update:modelValue", y);
      }
    }
    function yt() {
      vt.forEach((i) => {
        u.store.on(i, (...o) => {
          t.emit.apply(t, [i, ...o]);
        });
      });
    }
    function Ee() {
      h.value = 0, g.value = 0, B.value && (B.value.scrollTop = 0);
    }
    function Ve() {
      u.blockNodes = u.store.flatData.filter(
        (i) => i.visible
      ), ge(), re();
    }
    function ge() {
      r.value = u.blockNodes.length, d.value = e.nodeMinHeight * r.value;
    }
    function re() {
      Te(), ke();
    }
    function Te() {
      const i = B.value.clientHeight;
      A.value = Math.max(
        e.renderNodeAmount,
        Math.ceil(i / e.nodeMinHeight) + e.bufferNodeAmount
      );
    }
    function ke(i = !1) {
      if (r.value > A.value) {
        const o = B.value.scrollTop, y = Math.floor(o / e.nodeMinHeight);
        L.value = Math.floor(y / e.bufferNodeAmount) * e.bufferNodeAmount;
      } else
        L.value = 0;
      i && V.value === A.value && Q.value === L.value || (s.value = u.blockNodes.slice(L.value, L.value + A.value).map((o) => Object.assign({}, o, {
        _parent: null,
        children: []
      })), h.value = L.value * e.nodeMinHeight, g.value = d.value - (h.value + s.value.length * e.nodeMinHeight));
    }
    function Ct() {
      X.value && window.cancelAnimationFrame(X.value), V.value = A.value, Q.value = L.value, X.value = window.requestAnimationFrame(
        ke.bind(null, !0)
      );
    }
    const Kt = {
      setData: x,
      setChecked: P,
      setCheckedKeys: N,
      checkAll: c,
      clearChecked: f,
      setSelected: D,
      clearSelected: S,
      setExpand: _,
      setExpandKeys: ae,
      setExpandAll: Ye,
      getCheckedNodes: ze,
      getCheckedKeys: qe,
      getIndeterminateNodes: Je,
      getSelectedNode: Ge,
      getSelectedKey: Qe,
      getExpandNodes: Ze,
      getExpandKeys: et,
      getCurrentVisibleNodes: tt,
      getTreeData: nt,
      getFlatData: lt,
      getNodesCount: at,
      insertBefore: st,
      insertAfter: it,
      append: rt,
      prepend: dt,
      remove: ot,
      filter: ct,
      showCheckedNodes: ut,
      loadRootNodes: Ke,
      scrollTo: ht,
      updateExpandedKeys: pe,
      updateUnloadStatus: Ae,
      handleTreeScroll: Ct,
      handleNodeCheck: ft,
      handleNodeSelect: pt,
      handleNodeExpand: gt,
      handleNodeDrop: kt,
      emitCheckableInput: Fe,
      emitSelectableInput: Ie,
      // attachStoreEvents,
      resetSpaceHeights: Ee,
      updateBlockNodes: Ve,
      updateBlockData: ge,
      updateRender: re,
      updateRenderAmount: Te,
      updateRenderNodes: ke,
      getNode: $e
    };
    return We(() => {
      u.store.on("visible-data-change", Ve), u.store.on("render-data-change", re), u.store.on(
        "checked-change",
        (o, y) => {
          Fe(o, y), Ae();
        }
      ), u.store.on("selected-change", Ie), e.data.length ? (x(e.data), e.defaultExpandedKeys.length && u.store.setExpandKeys(e.defaultExpandedKeys, !0)) : typeof e.load == "function" && e.autoLoad && ((e.modelValue || e.unloadDataList) && x([]), Ke());
      const i = M.value;
      i != null && i.contentWindow && i.contentWindow.addEventListener("resize", re);
    }), It(() => {
      const i = M.value;
      i != null && i.contentWindow && i.contentWindow.removeEventListener("resize", re), u.store.disposeListeners();
      const o = E();
      u.store = o.store, u.blockNodes = o.blockNodes;
    }), yt(), {
      nonReactive: u,
      /** 未加载选中的节点，展示已选时生成，其他情况下没用 */
      unloadCheckedNodes: a,
      /** 可见节点个数 */
      blockLength: r,
      /** 可见节点总高度 */
      blockAreaHeight: d,
      /** 顶部填充高度 */
      topSpaceHeight: h,
      /** 底部填充高度 */
      bottomSpaceHeight: g,
      /** 实际渲染节点个数 */
      renderAmount: A,
      /** renderAmount 缓存 */
      renderAmountCache: V,
      /** 渲染节点（实际渲染节点） */
      renderNodes: s,
      /** 渲染开始下标 */
      renderStart: L,
      /** renderStart 缓存 */
      renderStartCache: Q,
      /** 是否正在载入根节点，组件内部调用 load 时会改变此值 */
      isRootLoading: w,
      /** 缓存的 value ，用于 value 变化时与之做比对 */
      valueCache: T,
      /** 防抖计时器 id */
      debounceTimer: X,
      topSpaceStyles: H,
      bottomSpaceStyles: ie,
      wrapperCls: Z,
      scrollAreaCls: Y,
      blockAreaCls: te,
      emptyCls: ne,
      emptyTextDefaultCls: ee,
      loadingCls: le,
      loadingWrapperCls: z,
      loadingIconCls: W,
      iframeCls: k,
      treeNodeListeners: C,
      setData: x,
      setChecked: P,
      setCheckedKeys: N,
      checkAll: c,
      clearChecked: f,
      setSelected: D,
      clearSelected: S,
      setExpand: _,
      setExpandKeys: ae,
      setExpandAll: Ye,
      getCheckedNodes: ze,
      getCheckedKeys: qe,
      getIndeterminateNodes: Je,
      getSelectedNode: Ge,
      getSelectedKey: Qe,
      getExpandNodes: Ze,
      getExpandKeys: et,
      getCurrentVisibleNodes: tt,
      getTreeData: nt,
      getFlatData: lt,
      getNodesCount: at,
      insertBefore: st,
      insertAfter: it,
      append: rt,
      prepend: dt,
      remove: ot,
      filter: ct,
      showCheckedNodes: ut,
      loadRootNodes: Ke,
      scrollTo: ht,
      updateExpandedKeys: pe,
      updateUnloadStatus: Ae,
      handleTreeScroll: Ct,
      handleNodeCheck: ft,
      handleNodeSelect: pt,
      handleNodeExpand: gt,
      handleNodeDrop: kt,
      emitCheckableInput: Fe,
      emitSelectableInput: Ie,
      attachStoreEvents: yt,
      resetSpaceHeights: Ee,
      updateBlockNodes: Ve,
      updateBlockData: ge,
      updateRender: re,
      updateRenderAmount: Te,
      updateRenderNodes: ke,
      getNode: $e,
      scrollArea: B,
      iframe: M,
      methods: Kt
    };
  }
});
function qt(e, t, n, l, a, s) {
  const r = we("CTreeNode"), d = we("LoadingIcon");
  return O(), j("div", {
    class: m(e.wrapperCls)
  }, [
    v("div", {
      ref: "scrollArea",
      class: m(e.scrollAreaCls),
      onScrollPassive: t[0] || (t[0] = Nt((...h) => e.handleTreeScroll && e.handleTreeScroll(...h), ["stop"]))
    }, [
      v("div", {
        class: m(e.blockAreaCls)
      }, [
        v("div", {
          style: Oe(e.topSpaceStyles)
        }, null, 4),
        (O(!0), j(Pe, null, Xe(e.renderNodes, (h) => (O(), Re(r, ce(e.$props, {
          key: h[e.keyField],
          data: h,
          getNode: e.getNode
        }, Me(e.treeNodeListeners), {
          class: typeof e.nodeClassName == "function" ? e.nodeClassName(h) : e.nodeClassName,
          style: {
            minHeight: `${e.nodeMinHeight}px`,
            paddingLeft: `${h._level * e.nodeIndent}px`
          },
          onCheck: e.handleNodeCheck,
          onSelect: e.handleNodeSelect,
          onExpand: e.handleNodeExpand,
          onNodeDrop: e.handleNodeDrop
        }), null, 16, ["data", "getNode", "class", "style", "onCheck", "onSelect", "onExpand", "onNodeDrop"]))), 128)),
        v("div", {
          style: Oe(e.bottomSpaceStyles)
        }, null, 4)
      ], 2)
    ], 34),
    ue(v("div", {
      class: m(e.emptyCls)
    }, [
      v("span", {
        class: m(e.emptyTextDefaultCls)
      }, [
        G(e.$slots, "empty", {}, () => [
          je(he(e.emptyText), 1)
        ])
      ], 2)
    ], 2), [
      [Ne, !e.blockLength]
    ]),
    ue(v("div", {
      class: m(e.loadingCls)
    }, [
      v("div", {
        class: m(e.loadingWrapperCls)
      }, [
        G(e.$slots, "loading", {}, () => [
          De(d, {
            class: m(e.loadingIconCls)
          }, null, 8, ["class"])
        ])
      ], 2)
    ], 2), [
      [Ne, e.loading || e.isRootLoading]
    ]),
    v("iframe", {
      ref: "iframe",
      class: m(e.iframeCls)
    }, null, 2)
  ], 2);
}
const Jt = /* @__PURE__ */ fe(zt, [["render", qt]]);
function $t(e) {
  return Lt.reduce((t, n) => (t[n] = function(...l) {
    return e.value[n].apply(
      e.value,
      l
    );
  }, t), {});
}
const U = "ctree-tree-search", Ce = "ctree-tree-node", Gt = de({
  name: "CTreeSearch",
  inheritAttrs: !1,
  emits: ["checked-change", "search", "set-data", "update:modelValue"],
  components: {
    CTree: Jt
  },
  props: {
    /** 兼容 Vue 2.5.16 bug */
    modelValue: [String, Number, Array],
    /** 搜索输入框的 placeholder */
    searchPlaceholder: {
      type: String,
      default: "搜索关键字"
    },
    /** 是否显示全选复选框 */
    showCheckAll: {
      type: Boolean,
      default: !0
    },
    /** 是否显示已选按钮 */
    showCheckedButton: {
      type: Boolean,
      default: !0
    },
    /** 已选按钮文字 */
    checkedButtonText: {
      type: String,
      default: "已选"
    },
    /** 是否显示底部信息 */
    showFooter: {
      type: Boolean,
      default: !0
    },
    //#region Search related
    /** 如果传入此 Prop ，触发 `search` 事件后将会执行此方法，否则会执行组件内置的搜索方法 */
    searchMethod: Function,
    /** 触发搜索的字符长度 */
    searchLength: {
      type: Number,
      default: 1
    },
    /** 禁用搜索功能 */
    searchDisabled: {
      type: Boolean,
      default: !1
    },
    /** 是否远程搜索，传入 `searchMethod` 时无效 */
    searchRemote: {
      type: Boolean,
      default: !1
    },
    /** 搜索防抖时间，单位为毫秒 */
    searchDebounceTime: {
      type: Number,
      default: 300
    }
    //#endregion Search related
  },
  setup(e, { emit: t, attrs: n, expose: l }) {
    const a = Ue({
      checked: !1,
      /** 半选 */
      indeterminate: !1,
      /** 禁用 */
      disabled: !1
    }), s = b(!1), r = b(""), d = b(void 0), h = b(0), g = b();
    let A = $t(g);
    const V = p({
      get: () => e.modelValue,
      set: (N) => {
        E(), t("update:modelValue", N);
      }
    }), L = p(() => [`${U}__wrapper`]), Q = p(() => [`${U}__search`]), w = p(() => [`${U}__check-all-wrapper`]), T = p(() => [
      `${U}__check-all`,
      `${Ce}__checkbox`,
      {
        [`${Ce}__checkbox_checked`]: a.checked,
        [`${Ce}__checkbox_indeterminate`]: a.indeterminate,
        [`${Ce}__checkbox_disabled`]: e.searchDisabled || a.disabled
      }
    ]), X = p(() => [`${U}__input-wrapper`]), B = p(() => [
      `${U}__input`,
      {
        [`${U}__input_disabled`]: e.searchDisabled
      }
    ]), M = p(() => [`${U}__action-wrapper`]), H = p(() => [
      `${U}__checked-button`,
      {
        [`${U}__checked-button_active`]: s.value
      }
    ]), ie = p(() => [`${U}__tree-wrapper`]), Z = p(() => [`${U}__footer`]), Y = p(() => "checkable" in n && n.checkable !== !1);
    function te() {
      r.value = "";
    }
    function ne() {
      return r.value;
    }
    function ee(N) {
      let c = N;
      return typeof N != "string" && (c = r.value), new Promise((f, D) => {
        clearTimeout(d.value), d.value = setTimeout(() => {
          if (!(c.length > 0 && c.length < e.searchLength))
            if (s.value = !1, t("search", c), typeof e.searchMethod == "function") {
              const S = e.searchMethod(c);
              Promise.resolve(S).then(() => {
                C(), f();
              });
            } else
              e.searchRemote ? g.value.loadRootNodes().then(() => {
                C(), f();
              }) : (g.value.filter(c), C(), f());
        }, e.searchDebounceTime);
      });
    }
    function le() {
      if (e.searchDisabled || a.disabled)
        return;
      const N = g.value.getCurrentVisibleNodes().map((c) => c[g.value.keyField]);
      a.checked || a.indeterminate ? g.value.setCheckedKeys(N, !1) : g.value.setCheckedKeys(N, !0), C();
    }
    function z() {
      ee();
    }
    function W() {
      const N = () => {
        s.value = !s.value, s.value ? g.value.showCheckedNodes() : g.value.filter(r.value, () => !0), C();
      };
      r.value ? (te(), ee().then(() => {
        N();
      })) : N();
    }
    function k() {
      E(), C();
    }
    function C() {
      const N = g.value.getCurrentVisibleNodes(), c = N.length;
      let f = !1, D = !1, S = !1;
      for (let _ = 0; _ < c; _++) {
        const ae = N[_];
        if (ae.checked ? f = !0 : D = !0, f && D || ae.indeterminate) {
          S = !0, a.checked = !1, a.indeterminate = !0;
          break;
        }
      }
      S || (a.checked = f, a.indeterminate = !1);
    }
    function E() {
      h.value = g.value.getCheckedKeys().length;
    }
    function u(N, c) {
      C(), t("checked-change", N, c);
    }
    function x() {
      t("set-data"), k();
    }
    return We(() => {
      Y.value && !h.value && k();
    }), {
      ...A,
      treeModelValue: V,
      setChecked: (N, c) => {
        g.value.setChecked(N, c);
      },
      checkAllStatus: a,
      isShowingChecked: s,
      keyword: r,
      debounceTimer: d,
      checkedCount: h,
      wrapperCls: L,
      searchCls: Q,
      checkAllWrapperCls: w,
      checkboxCls: T,
      inputWrapperCls: X,
      inputCls: B,
      actionWrapperCls: M,
      checkedButtonCls: H,
      treeWrapperCls: ie,
      footerCls: Z,
      checkable: Y,
      treeRef: g,
      handleCheckAll: le,
      handleSearch: z,
      handleShowChecked: W,
      updateCheckedCount: E,
      handleSetData: k,
      updateCheckAllStatus: C,
      getKeyword: ne,
      checkedChange: u,
      onSetData: x,
      clearKeyword: te,
      search: ee
    };
  }
}), Qt = ["placeholder", "disabled"], Zt = { style: { float: "right" } };
function en(e, t, n, l, a, s) {
  const r = we("CTree");
  return O(), j("div", {
    class: m(e.wrapperCls)
  }, [
    v("div", {
      class: m(e.searchCls)
    }, [
      e.showCheckAll && e.checkable ? (O(), j("div", {
        key: 0,
        class: m(e.checkAllWrapperCls)
      }, [
        v("div", {
          class: m(e.checkboxCls),
          onClick: t[0] || (t[0] = (...d) => e.handleCheckAll && e.handleCheckAll(...d))
        }, null, 2)
      ], 2)) : oe("", !0),
      v("div", {
        class: m(e.inputWrapperCls)
      }, [
        G(e.$slots, "search-input", {}, () => [
          ue(v("input", {
            "onUpdate:modelValue": t[1] || (t[1] = (d) => e.keyword = d),
            type: "text",
            class: m(e.inputCls),
            placeholder: e.searchPlaceholder,
            disabled: e.searchDisabled,
            onInput: t[2] || (t[2] = (...d) => e.handleSearch && e.handleSearch(...d))
          }, null, 42, Qt), [
            [Vt, e.keyword]
          ])
        ])
      ], 2),
      v("div", {
        class: m(e.actionWrapperCls)
      }, [
        e.showCheckedButton && e.checkable ? (O(), j("span", {
          key: 0,
          class: m(e.checkedButtonCls),
          onClick: t[3] || (t[3] = (...d) => e.handleShowChecked && e.handleShowChecked(...d))
        }, he(e.checkedButtonText), 3)) : oe("", !0),
        G(e.$slots, "actions")
      ], 2)
    ], 2),
    v("div", {
      class: m(e.treeWrapperCls)
    }, [
      De(r, ce({ ref: "treeRef" }, e.$attrs, {
        modelValue: e.treeModelValue,
        "onUpdate:modelValue": t[4] || (t[4] = (d) => e.treeModelValue = d),
        onSetData: e.onSetData,
        onCheckedChange: e.checkedChange
      }), wt({ _: 2 }, [
        Xe(e.$slots, (d, h) => ({
          name: "default",
          fn: xe((g) => [
            G(e.$slots, h, be(ve(g)))
          ])
        }))
      ]), 1040, ["modelValue", "onSetData", "onCheckedChange"])
    ], 2),
    e.showFooter && e.checkable ? (O(), j("div", {
      key: 0,
      class: m(e.footerCls)
    }, [
      G(e.$slots, "footer", {}, () => [
        v("span", Zt, "已选 " + he(e.checkedCount) + " 个", 1)
      ])
    ], 2)) : oe("", !0)
  ], 2);
}
const tn = /* @__PURE__ */ fe(Gt, [["render", en]]), q = "ctree-tree-drop", St = "ctree-tree-search", nn = de({
  name: "CTreeDrop",
  inheritAttrs: !1,
  emits: [
    "clear",
    "checked-change",
    "dropdown-visible-change",
    "update:modelValue"
  ],
  components: {
    CTreeSearch: tn
  },
  props: {
    /** 兼容 Vue 2.5.16 bug */
    modelValue: [String, Number, Array],
    /** 下拉内容高度 */
    dropHeight: {
      type: Number,
      default: 300
    },
    /** 展示输入框 placeholder */
    dropPlaceholder: {
      type: String
    },
    /** 是否禁用 */
    dropDisabled: {
      type: Boolean,
      default: !1
    },
    /** 允许清空 */
    clearable: {
      type: Boolean,
      default: !1
    },
    /** 下拉弹出框位置 */
    placement: {
      type: String,
      default: Dt["bottom-start"]
    },
    /** 将下拉 DOM 转移到 body 中 */
    transfer: {
      type: Boolean,
      default: !1
    },
    /** 在下拉框容器上额外添加的 class */
    dropdownClassName: [String, Array],
    /** 下拉框容器最小宽度，未指定则默认为展示输入框宽度 */
    dropdownMinWidth: {
      type: Number
    },
    /** 固定下拉框容器宽度，当内容超出最小宽度不会伸长，而是出现横向滚动条 */
    dropdownWidthFixed: {
      type: Boolean,
      default: !1
    }
  },
  setup(e, { attrs: t, emit: n }) {
    const l = b(!1), a = b(0), s = b(""), r = b(), d = b(), h = b(), g = Ue({
      /** 多选选中的节点 */
      checkedNodes: [],
      /** 多选选中的节点 key */
      checkedKeys: [],
      /** 单选选中的节点 */
      selectedNode: void 0,
      /** 单选选中的节点 key */
      selectedKey: void 0
    }), A = p({
      get: () => e.modelValue,
      set: (k) => {
        n("update:modelValue", k);
      }
    }), V = p(() => [`${q}__wrapper`]), L = p(() => [`${q}__reference`]), Q = p(() => [
      `${St}__input`,
      `${q}__display-input`,
      {
        [`${q}__display-input_focus`]: l.value,
        [`${St}__input_disabled`]: e.dropDisabled
      }
    ]), w = p(() => {
      let k = !1;
      return typeof e.dropPlaceholder == "string" && (M.value ? k = a.value === 0 : H.value && (k = s.value === "")), [
        `${q}__display-input-text`,
        {
          [`${q}__display-input-placeholder`]: k
        }
      ];
    }), T = p(() => [
      `${q}__display-icon-drop`,
      {
        [`${q}__display-icon-drop_active`]: l.value
      }
    ]), X = p(() => [`${q}__display-icon-clear`]), B = p(() => {
      const k = Array.isArray(e.dropdownClassName) ? e.dropdownClassName : [e.dropdownClassName];
      return [`${q}__dropdown`, ...k];
    }), M = p(() => "checkable" in t && t.checkable !== !1), H = p(() => "selectable" in t && t.selectable !== !1), ie = p(() => M.value ? a.value === 0 && typeof e.dropPlaceholder == "string" ? e.dropPlaceholder : `已选 ${a.value} 个` : H.value ? s.value === "" && typeof e.dropPlaceholder == "string" ? e.dropPlaceholder : s.value : e.dropPlaceholder || ""), Z = p(() => M.value ? a.value !== 0 : H.value ? s.value !== "" : !1);
    function Y() {
      const k = r.value.getBoundingClientRect(), C = k.width, E = k.height, u = `${typeof e.dropdownMinWidth == "number" ? e.dropdownMinWidth : C}px`;
      d.value.style.minWidth = u, d.value.style.width = e.dropdownWidthFixed ? u : "auto";
      const x = d.value.getBoundingClientRect(), P = window.getComputedStyle(
        d.value
      ), N = parseFloat(P.marginLeft) + parseFloat(P.marginRight), c = parseFloat(P.marginTop) + parseFloat(P.marginBottom), f = x.width + N, D = x.height / 0.8 + c;
      let S = 0, _ = 0;
      switch (e.transfer && (S = -999, _ = -999), e.placement) {
        case "bottom-start":
          e.transfer ? (S = window.pageYOffset + k.bottom, _ = window.pageXOffset + k.left) : S = E;
          break;
        case "bottom-end":
          e.transfer ? (S = window.pageYOffset + k.bottom, _ = window.pageXOffset + k.right - f) : (S = E, _ = C - f);
          break;
        case "bottom":
          e.transfer ? (S = window.pageYOffset + k.bottom, _ = window.pageXOffset + k.left + (C - f) / 2) : (S = E, _ = (C - f) / 2);
          break;
        case "top-start":
          e.transfer ? (S = window.pageYOffset + k.top - D, _ = window.pageXOffset + k.left) : S = -D;
          break;
        case "top-end":
          e.transfer ? (S = window.pageYOffset + k.top - D, _ = window.pageXOffset + k.right - f) : (S = -D, _ = C - f);
          break;
        case "top":
          e.transfer ? (S = window.pageYOffset + k.top - D, _ = window.pageXOffset + k.left + (C - f) / 2) : (S = -D, _ = (C - f) / 2);
          break;
      }
      d.value.style.top = `${S}px`, d.value.style.left = `${_}px`;
    }
    function te() {
      e.dropDisabled || (l.value = !l.value);
    }
    function ne(k) {
      var C, E;
      !((C = r.value) != null && C.contains(k.target)) && !((E = d.value) != null && E.contains(k.target)) && (l.value = !1);
    }
    function ee() {
      n("clear"), M.value ? h.value.clearChecked() : H.value && h.value.clearSelected();
    }
    function le(k, C) {
      g.checkedNodes = k, g.checkedKeys = C, a.value = C.length, n("checked-change", k, C);
    }
    function z(k, C) {
      if (g.selectedNode = k, g.selectedKey = C, k) {
        const E = h.value.$refs.treeRef.titleField;
        s.value = k[E];
      } else
        C ? s.value = C : s.value = "";
      l.value = !1;
    }
    function W() {
      const k = h.value.$refs.treeRef;
      if (g.checkedNodes = h.value.getCheckedNodes(), g.checkedKeys = h.value.getCheckedKeys(), g.selectedNode = h.value.getSelectedNode(), g.selectedKey = h.value.getSelectedKey(), M.value && (a.value = g.checkedKeys.length), H.value && e.modelValue != null) {
        const C = h.value.getNode(
          e.modelValue
        );
        if (C) {
          const E = k.titleField;
          s.value = C[E];
        } else
          s.value = e.modelValue;
      }
    }
    return We(() => {
      document.addEventListener("click", ne), e.transfer && document.body.appendChild(d.value), W();
    }), me(
      () => l.value,
      (k) => {
        n("dropdown-visible-change", k), k ? Et(() => {
          Y();
        }) : h.value.getKeyword() && (h.value.clearKeyword(), h.value.search());
      }
    ), {
      ...$t(h),
      treeSearchValue: A,
      dropdownVisible: l,
      checkedCount: a,
      selectedTitle: s,
      slotProps: g,
      wrapperCls: V,
      referenceCls: L,
      displayInputCls: Q,
      displayInputTextCls: w,
      dropIconCls: T,
      clearIconCls: X,
      dropdownCls: B,
      checkable: M,
      selectable: H,
      displayValue: ie,
      showClearIcon: Z,
      referenceRef: r,
      dropdownRef: d,
      treeSearchRef: h,
      locateDropdown: Y,
      handleRefClick: te,
      handleDocumentClick: ne,
      handleClear: ee,
      handleCheckedChange: le,
      handleSelectedChange: z,
      handleSetData: W
    };
  }
});
function ln(e, t, n, l, a, s) {
  const r = we("CTreeSearch");
  return O(), j("div", {
    class: m(e.wrapperCls)
  }, [
    v("div", {
      ref: "referenceRef",
      class: m(e.referenceCls),
      onClick: t[1] || (t[1] = (...d) => e.handleRefClick && e.handleRefClick(...d))
    }, [
      G(e.$slots, "default", be(ve(e.slotProps)), () => [
        v("div", {
          class: m(e.displayInputCls)
        }, [
          v("span", {
            class: m(e.displayInputTextCls)
          }, [
            G(e.$slots, "display", be(ve(e.slotProps)), () => [
              je(he(e.displayValue), 1)
            ])
          ], 2),
          e.dropDisabled ? oe("", !0) : (O(), j(Pe, { key: 0 }, [
            v("i", {
              class: m(e.dropIconCls)
            }, null, 2),
            e.clearable && e.showClearIcon ? G(e.$slots, "clear", { key: 0 }, () => [
              v("i", {
                class: m(e.clearIconCls),
                onClick: t[0] || (t[0] = Nt((...d) => e.handleClear && e.handleClear(...d), ["stop"]))
              }, null, 2)
            ]) : oe("", !0)
          ], 64))
        ], 2)
      ])
    ], 2),
    De(Tt, { name: "ctree-dropdown" }, {
      default: xe(() => [
        ue(v("div", {
          ref: "dropdownRef",
          class: m(e.dropdownCls),
          style: Oe({
            height: `${e.dropHeight}px`
          })
        }, [
          De(r, ce({
            ref: "treeSearchRef",
            modelValue: e.treeSearchValue,
            "onUpdate:modelValue": t[2] || (t[2] = (d) => e.treeSearchValue = d)
          }, e.$attrs, {
            onSetData: e.handleSetData,
            onCheckedChange: e.handleCheckedChange,
            onSelectedChange: e.handleSelectedChange
          }), wt({ _: 2 }, [
            Xe(e.$slots, (d, h) => ({
              name: h,
              fn: xe((g) => [
                G(e.$slots, h, be(ve(g)))
              ])
            }))
          ]), 1040, ["modelValue", "onSetData", "onCheckedChange", "onSelectedChange"])
        ], 6), [
          [Ne, e.dropdownVisible]
        ])
      ]),
      _: 3
    })
  ], 2);
}
const dn = /* @__PURE__ */ fe(nn, [["render", ln]]);
export {
  se as TreeNode,
  Mt as TreeStore,
  dn as VTreeDrop,
  Xt as VTreeNode,
  tn as VTreeSearch,
  Jt as default
};
